var L = Object.defineProperty;
var q = (n, e, s) => e in n ? L(n, e, { enumerable: !0, configurable: !0, writable: !0, value: s }) : n[e] = s;
var i = (n, e, s) => (q(n, typeof e != "symbol" ? e + "" : e, s), s);
import { defineComponent as S, ref as I, computed as g, openBlock as f, createElementBlock as h, Fragment as T, withDirectives as C, normalizeStyle as u, unref as d, vShow as O, createCommentVNode as K, createElementVNode as c, resolveComponent as $, createVNode as y, normalizeClass as w, toDisplayString as b } from "vue";
function x(n) {
  return { all: n = n || /* @__PURE__ */ new Map(), on: function(e, s) {
    var t = n.get(e);
    t ? t.push(s) : n.set(e, [s]);
  }, off: function(e, s) {
    var t = n.get(e);
    t && (s ? t.splice(t.indexOf(s) >>> 0, 1) : n.set(e, []));
  }, emit: function(e, s) {
    var t = n.get(e);
    t && t.slice().map(function(o) {
      o(s);
    }), (t = n.get("*")) && t.slice().map(function(o) {
      o(e, s);
    });
  } };
}
class A {
  constructor() {
    i(this, "emitter", x());
    i(this, "showLoaderKey", "showLoader");
    i(this, "hideLoaderKey", "hideLoader");
    i(this, "showToastKey", "showToast");
    return this;
  }
  on(e, s) {
    this.emitter.on(e, s);
  }
  off(e, s) {
    this.emitter.off(e, s);
  }
  emit(e, s = null) {
    this.emitter.emit(e, s);
  }
}
const a = new A(), D = /* @__PURE__ */ S({
  __name: "AnLoader",
  props: {
    color: {
      type: String,
      default: "#4a8df8"
    },
    height: {
      type: Number,
      default: 2
    },
    showOverlay: {
      type: Boolean,
      default: !0
    },
    overlayOpacity: {
      type: Number,
      default: 0.4
    }
  },
  setup(n) {
    const e = n, s = I(!1), t = g(() => `height:${e.height}px;visibility:${s.value ? "visible" : "hidden"}`), o = g(() => `background: ${e.color}; height: ${e.height}px;`), m = g(() => `background-color: rgba(0, 0, 0, ${e.overlayOpacity});`);
    let r = 0;
    const l = () => {
      r += 1, r === 1 && (s.value = !0);
    }, p = () => {
      r > 0 && (r -= 1), r === 0 && (s.value = !1);
    };
    return a.on(a.showLoaderKey, l), a.on(a.hideLoaderKey, p), (v, _) => (f(), h(T, null, [
      n.showOverlay ? C((f(), h("div", {
        key: 0,
        class: "an-overlay",
        style: u(d(m))
      }, null, 4)), [
        [O, s.value]
      ]) : K("", !0),
      c("div", {
        class: "an-slider",
        style: u(d(t))
      }, [
        c("div", {
          class: "an-line",
          style: u(d(o))
        }, null, 4),
        c("div", {
          class: "an-subline an-inc",
          style: u(d(o))
        }, null, 4),
        c("div", {
          class: "an-subline an-dec",
          style: u(d(o))
        }, null, 4)
      ], 4)
    ], 64));
  }
});
const z = /* @__PURE__ */ S({
  __name: "AnToasts",
  props: {
    closeIcon: {
      required: !1,
      type: Object
    },
    errorClasses: {
      required: !1,
      type: String
    },
    errorIcon: {
      required: !1,
      type: Object
    },
    warnClasses: {
      required: !1,
      type: String
    },
    warnIcon: {
      required: !1,
      type: Object
    },
    infoClasses: {
      required: !1,
      type: String
    },
    infoIcon: {
      required: !1,
      type: Object
    },
    doneClasses: {
      required: !1,
      type: String
    },
    doneIcon: {
      required: !1,
      type: Object
    }
  },
  setup(n) {
    const e = n;
    return (s, t) => {
      const o = $("an-toast");
      return f(), h(T, null, [
        y(o, {
          type: "error",
          classes: e.errorClasses,
          icon: e.errorIcon,
          "close-icon": e.closeIcon
        }, null, 8, ["classes", "icon", "close-icon"]),
        y(o, {
          type: "warning",
          classes: e.warnClasses,
          icon: e.warnIcon,
          "close-icon": e.closeIcon
        }, null, 8, ["classes", "icon", "close-icon"]),
        y(o, {
          type: "info",
          classes: e.infoClasses,
          icon: e.infoIcon,
          "close-icon": e.closeIcon
        }, null, 8, ["classes", "icon", "close-icon"]),
        y(o, {
          type: "done",
          classes: e.doneClasses,
          icon: e.doneIcon,
          "close-icon": e.closeIcon
        }, null, 8, ["classes", "icon", "close-icon"])
      ], 64);
    };
  }
}), j = /* @__PURE__ */ S({
  __name: "AnToast",
  props: {
    type: {
      required: !0,
      type: String
    },
    classes: {
      required: !1,
      type: String,
      default: "an-toast-default an-toast-layout-default bottom"
    },
    icon: {
      required: !1,
      type: Object
    },
    closeIcon: {
      required: !1,
      type: Object,
      default: { content: "X" }
    }
  },
  setup(n) {
    const e = n, s = I(""), t = I(!1);
    let o = null;
    const m = (l) => {
      if (l.type === e.type) {
        if (t.value) {
          console.log(`there is currently another ${e.type}-toast visible`);
          return;
        }
        s.value = l.message || "", t.value = !0, o = window.setTimeout(r, l.duration);
      }
    }, r = () => {
      o && (window.clearTimeout(o), o = null), t.value = !1, s.value = "";
    };
    return a.on(a.showToastKey, m), (l, p) => {
      var v, _;
      return f(), h("div", {
        class: w(["an-toast", `${n.classes} ${t.value ? "active" : ""}`]),
        onClick: p[0] || (p[0] = (E) => r())
      }, [
        c("i", {
          class: w((v = e.icon) == null ? void 0 : v.class)
        }, b((_ = e.icon) == null ? void 0 : _.content), 3),
        c("span", null, b(s.value), 1),
        c("i", {
          class: w(e.closeIcon.class)
        }, b(e.closeIcon.content), 3)
      ], 2);
    };
  }
});
const k = (n, e) => {
  const s = n.__vccOpts || n;
  for (const [t, o] of e)
    s[t] = o;
  return s;
}, F = /* @__PURE__ */ k(j, [["__scopeId", "data-v-275edef7"]]);
class N {
  constructor() {
    return this;
  }
  showLoader() {
    a.emit(a.showLoaderKey);
  }
  hideLoader() {
    a.emit(a.hideLoaderKey);
  }
}
const M = new N();
class P {
  constructor() {
    return this;
  }
  getParams(e, s, t, o) {
    return {
      type: e,
      message: s,
      duration: t,
      param: o
    };
  }
  showError(e, s, t) {
    const o = this.getParams("error", e, t || 5e7, s);
    a.emit(a.showToastKey, o);
  }
  showWarning(e, s, t) {
    const o = this.getParams("warning", e, t || 5e3, s);
    a.emit(a.showToastKey, o);
  }
  showInfo(e, s, t) {
    const o = this.getParams("info", e, t || 5e3, s);
    a.emit(a.showToastKey, o);
  }
  showDone(e, s, t) {
    const o = this.getParams("done", e, t || 1e3, s);
    a.emit(a.showToastKey, o);
  }
}
const R = new P();
export {
  D as AnLoader,
  F as AnToast,
  z as AnToasts,
  A as EventService,
  N as LoaderService,
  P as ToastService,
  a as eventService,
  M as loaderService,
  R as toastService
};
