import { PropType, ref } from 'vue';
import { ToastParams, ToastType } from '../services/ToastService';
export declare type AnIcon = {
    class?: string;
    content?: string;
};
declare const _sfc_main: import("vue").DefineComponent<{
    type: {
        required: true;
        type: PropType<ToastType>;
    };
    classes: {
        required: false;
        type: StringConstructor;
        default: string;
    };
    icon: {
        required: false;
        type: PropType<AnIcon>;
    };
    closeIcon: {
        required: false;
        type: PropType<AnIcon>;
        default: {
            content: string;
        };
    };
}, {
    props: Readonly<import("@vue/shared").LooseRequired<Readonly<import("vue").ExtractPropTypes<{
        type: {
            required: true;
            type: PropType<ToastType>;
        };
        classes: {
            required: false;
            type: StringConstructor;
            default: string;
        };
        icon: {
            required: false;
            type: PropType<AnIcon>;
        };
        closeIcon: {
            required: false;
            type: PropType<AnIcon>;
            default: {
                content: string;
            };
        };
    }>> & {
        [x: string & `on${string}`]: ((...args: any[]) => any) | ((...args: unknown[]) => any) | undefined;
    }>>;
    message: import("vue").Ref<string>;
    active: import("vue").Ref<boolean>;
    timerId: null;
    showToast: (toast: ToastParams) => void;
    hideToast: () => void;
    PropType: any;
    ref: typeof ref;
    eventService: import("../services/EventService").EventService;
    ToastParams: any;
    ToastType: any;
}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, Record<string, any>, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    type: {
        required: true;
        type: PropType<ToastType>;
    };
    classes: {
        required: false;
        type: StringConstructor;
        default: string;
    };
    icon: {
        required: false;
        type: PropType<AnIcon>;
    };
    closeIcon: {
        required: false;
        type: PropType<AnIcon>;
        default: {
            content: string;
        };
    };
}>>, {
    classes: string;
    closeIcon: AnIcon;
}>;
export default _sfc_main;
