import { EventType } from 'mitt';
export declare class EventService {
    emitter: import("mitt").Emitter<Record<EventType, unknown>>;
    readonly showLoaderKey = "showLoader";
    readonly hideLoaderKey = "hideLoader";
    readonly showToastKey = "showToast";
    constructor();
    on(eventType: string | symbol | '*', handler: (e: any) => void): void;
    off(eventType: string | symbol | '*', handler: (e: any) => void): void;
    emit(eventType: string, arg?: any): void;
}
export declare const eventService: EventService;
